﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data.OleDb;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Timers;
using Microsoft.Office.Interop.Access;
using Microsoft.Office.Interop.Access.Dao;

namespace ZugriffAufAccess
{
    class Program
    {
        // Hier muss der Connection String angepasst werden auf den korrekten Pfad der Access DAtei.
        private static string Connectionstring = @"C:\Entwicklung\AEK\Access_Interop_DotNet\MeineDatenbank.accdb";
        static void Main(string[] args)
        {

            string NettoZeit = "";

            Stopwatch timer = new Stopwatch();
  
            timer.Reset();
            timer.Start();

            NettoZeit = ErmittelGehaltBisZurRente(5000000, 0);
            timer.Stop();
            Console.WriteLine(" ");
            Console.WriteLine(" Ohne Array 5000000 - Netto:{0}   - Brutto: {1}", NettoZeit, timer.Elapsed.TotalSeconds.ToString("0.000000"));
            Console.WriteLine(" ");
            Console.WriteLine(" ");
            Console.WriteLine(" ");

            timer.Reset();
            timer.Start();
            NettoZeit = ErmittelGehaltBisZurRenteAlsArray(5000, 0);
            timer.Stop();
            Console.WriteLine(" ");
            Console.WriteLine(" Mit Array  5000 - Netto:{0}   - Brutto: {1}", NettoZeit, timer.Elapsed.TotalSeconds.ToString("0.000000"));
            Console.WriteLine(" ");
            Console.WriteLine(" ");
            Console.WriteLine(" ");


            timer.Reset();
            timer.Start();
            NettoZeit = ErmittelGehaltBisZurRenteAlsArray(50000, 0);
            timer.Stop();
            Console.WriteLine(" ");
            Console.WriteLine(" Mit Array  50000- Netto:{0}   - Brutto: {1}", NettoZeit, timer.Elapsed.TotalSeconds.ToString("0.000000"));
            Console.WriteLine(" ");
            Console.WriteLine(" ");
            Console.WriteLine(" ");




            timer.Reset();
            timer.Start();
            NettoZeit = ErmittelGehaltBisZurRenteAlsArray(500000, 0);
            timer.Stop();
            Console.WriteLine(" ");
            Console.WriteLine(" Mit Array  500000 - Netto:{0}   - Brutto: {1}", NettoZeit, timer.Elapsed.TotalSeconds.ToString("0.000000"));
            Console.WriteLine(" ");
            Console.ReadKey();

        }

      


        public static string ErmittelGehaltBisZurRente(int RentenAlter, decimal Gehaltssteigerung)
        {
            string returnvalue = "";
            try
            {


                var accApp = new Microsoft.Office.Interop.Access.Application();
                accApp.OpenCurrentDatabase(Connectionstring);
                Microsoft.Office.Interop.Access.Dao.Database cdb = accApp.CurrentDb();
           

                Stopwatch timer = new Stopwatch();

                timer.Reset();
                timer.Start();



                decimal summefox = 0;

                Microsoft.Office.Interop.Access.Dao.Recordset rst = cdb.OpenRecordset("SELECT * FROM Kunden", Microsoft.Office.Interop.Access.Dao.RecordsetTypeEnum.dbOpenSnapshot);
                Microsoft.Office.Interop.Access.Dao.Recordset Ergebnis = cdb.OpenRecordset("SELECT * FROM Ergebnis", Microsoft.Office.Interop.Access.Dao.RecordsetTypeEnum.dbOpenDynaset);
                while (!rst.EOF)
                {
                    decimal rente = 0;
                    decimal gehalt = 0;
                    int lMonateNoch = RentenAlter * 12;

                    gehalt = rst.Fields["Gehalt"].Value;
                    DateTime geburtstag = rst.Fields["Geburtsdatum"].Value;
                    DateTime jetzt = DateTime.Now;
                   
                    int aktuelleMonate = (geburtstag.Month - jetzt.Month) + 12 * (geburtstag.Year - jetzt.Year);

                    lMonateNoch = lMonateNoch + aktuelleMonate;

                    for (int i = 1; i < lMonateNoch; i++)
                    {
                        if (i % 12 == 0)
                        {
                            gehalt = gehalt + gehalt * Gehaltssteigerung;
                        }

                        rente = rente + gehalt;

                    }

                    
                    Ergebnis.AddNew();
                    Ergebnis.Fields["ErgebnisFuer"].Value = rst.Fields["Vorname"].Value + " " + rst.Fields["Nachname"].Value;
                    Ergebnis.Fields["ErgebnisZahl"].Value = rente;
                    Ergebnis.Update();
                    Ergebnis.MoveNext();

                    Console.WriteLine("{0} {1} bekommt eine Rente i.H.v. {2}", rst.Fields["Vorname"].Value, rst.Fields["Nachname"].Value, rente);

                    if (rst.Fields["Nachname"].Value == "Fox")
                    {
                        summefox = summefox + rente;
                    }


                 

                    rst.MoveNext();
                }
                rst.Close();

                
                Ergebnis.AddNew();
                Ergebnis.Fields["ErgebnisFuer"].Value = "Fox";
                Ergebnis.Fields["ErgebnisZahl"].Value = summefox;
                Ergebnis.Update();
                Ergebnis.Close();

                Console.WriteLine(" Familie Fox bekommt eine Rente i.H.v. {0}",summefox);

                timer.Stop();
                returnvalue = timer.Elapsed.TotalSeconds.ToString("0.000000");

                accApp.CloseCurrentDatabase();
                accApp.Quit();              
            }
            catch (Exception)
            {

                throw; //
            }
            finally
            {
                //
            }

            return returnvalue;

        }

        public static string ErmittelGehaltBisZurRenteAlsArray(int RentenAlter, decimal Gehaltssteigerung)
        {
            string returnvalue = "";
            try
            {


                var accApp = new Microsoft.Office.Interop.Access.Application();
                accApp.OpenCurrentDatabase(Connectionstring);
                Microsoft.Office.Interop.Access.Dao.Database cdb = accApp.CurrentDb();


                Stopwatch timer = new Stopwatch();

                timer.Reset();
                timer.Start();

                

                decimal summefox = 0;

                Microsoft.Office.Interop.Access.Dao.Recordset rst = cdb.OpenRecordset("SELECT * FROM Kunden", Microsoft.Office.Interop.Access.Dao.RecordsetTypeEnum.dbOpenSnapshot);
                Microsoft.Office.Interop.Access.Dao.Recordset Ergebnis = cdb.OpenRecordset("SELECT * FROM Ergebnis", Microsoft.Office.Interop.Access.Dao.RecordsetTypeEnum.dbOpenDynaset);
                while (!rst.EOF)
                {
                    decimal rente = 0;
                    decimal gehalt = 0;
                    int lMonateNoch = RentenAlter * 12;

                    gehalt = rst.Fields["Gehalt"].Value;
                    DateTime geburtstag = rst.Fields["Geburtsdatum"].Value;
                    DateTime jetzt = DateTime.Now;
                    List<decimal> list = new List<decimal>();
                    Collection<decimal> liste2 = new Collection<decimal>();
                   

                    int aktuelleMonate = (geburtstag.Month - jetzt.Month) + 12 * (geburtstag.Year - jetzt.Year);

                    lMonateNoch = lMonateNoch - aktuelleMonate;

                    for (int i = 1; i < lMonateNoch; i++)
                    {
                        if (i % 12 == 0)
                        {
                            gehalt = gehalt + gehalt * Gehaltssteigerung;
                        }


                        if (RentenAlter > 50000)
                        {
                            liste2.Add(gehalt);
                        }
                        else
                        {
                            list.Add(gehalt);    
                        }
                        
                        //rente = rente + gehalt;

                    }



                    if (RentenAlter > 50000)
                    {
                        rente = liste2.Sum();
                    }
                    else
                    {
                        foreach (var d in list)
                        {
                            rente = rente + d;
                        }
                    }



                    Ergebnis.AddNew();
                    Ergebnis.Fields["ErgebnisFuer"].Value = rst.Fields["Vorname"].Value + " " + rst.Fields["Nachname"].Value;
                    Ergebnis.Fields["ErgebnisZahl"].Value = rente;
                    Ergebnis.Update();
                    Ergebnis.MoveNext();
     

                    if (rst.Fields["Nachname"].Value == "Fox")
                    {
                        summefox = summefox + rente;
                    }


                    Console.WriteLine("{0} {1} bekommt eine Rente i.H.v. {2}", rst.Fields["Vorname"].Value, rst.Fields["Nachname"].Value, rente);

                    rst.MoveNext();
                }
                rst.Close();


                Ergebnis.AddNew();
                Ergebnis.Fields["ErgebnisFuer"].Value = "Fox";
                Ergebnis.Fields["ErgebnisZahl"].Value = summefox;
                Ergebnis.Update();
                Ergebnis.Close();

                Console.WriteLine(" Familie Fox bekommt eine Rente i.H.v. {0}", summefox);

                timer.Stop();
                returnvalue = timer.Elapsed.TotalSeconds.ToString("0.000000");

                accApp.CloseCurrentDatabase();
                accApp.Quit();
            }
            catch (Exception)
            {

                throw; //
            }
            finally
            {
                //
            }

            return returnvalue;

        }




        //http://converter.telerik.com/
    }
}
